;;;;;;;;;;;;;;;;;;;;;;;;
;;    Theme Shooter   ;;
;;;;;;;;;;;;;;;;;;;;;;;;

#include Gdip.ahk
#include xpath.ahk

Gui, Add, Text, x36 y20 w60 h20 , Theme.zip:
Gui, Add, Edit, x116 y20 w320 h20 vThemePath, 
Gui, Add, Button, x450 y20 w60 h20 gBrowse, Browse
Gui, Add, Button, x86 y50 w330 h40 gShoot, Make screenshot
Gui, Add, Button, x86 y100 w330 h40 gPreview, Preview Theme 
; Generated using SmartGUI Creator 4.0
Gui, Show, w520 h165, Theme Shooter
Return

GuiClose:
ExitApp

Shoot:
Gui, Submit, NoHide
ret := Generate()
if ret != 2
	ExitApp
If !ThemePath
	Return
GoSub Save
Return

Preview:
Gui, Submit, NoHide
ret := Generate()
if ret != 2
	ExitApp
;Display
Gui, 2: Add, Picture, x0 y0 w640 h480 0xE hwndimage_handle
Gui, 2: Add, Button, x170 y490 w300 h40 gPrevSave, Save
; Generated using SmartGUI Creator 4.0
hBitmap := Gdip_CreateHBITMAPFromBitmap(pBitmap)
SetImage(image_handle, hBitmap)
Gui, 2: Show, w640 h540, Preview
Return

Generate()
{
;Set working DIR to Script DIR
SetWorkingDir, %A_ScriptDir%

;Install fonts
Run, resources\fontinst.exe

;Startup GDI+
If !pToken := Gdip_Startup()
{
	MsgBox, 48, gdiplus error!, Gdiplus failed to start. Please ensure you have gdiplus on your system
	ExitApp
}
;Delete leftover files if they're still there
FileRemoveDir, theme, 1
;Gui, Submit, NoHide

global ThemePath

If !ThemePath
	Return

;Extract theme
RunWait, resources\7za.exe e "%ThemePath%" -otheme,, Hide

;Add default files if missing
IfNotExist, theme\bubble1.png
	FileCopy, resources\bubble1.png, theme\bubble1.png
IfNotExist, theme\bubble2.png
	FileCopy, resources\bubble2.png, theme\bubble2.png
IfNotExist, theme\bubble3.png
	FileCopy, resources\bubble3.png, theme\bubble3.png
IfNotExist, theme\apps_list.png
	FileCopy, resources\apps_list.png, theme\apps_list.png
IfNotExist, theme\apps_list_hover.png
	FileCopy, resources\apps_list_hover.png, theme\apps_list_hover.png
IfNotExist, theme\apps_next.png
	FileCopy, resources\apps_next.png, theme\apps_next.png
IfNotExist, theme\apps_previous.png
	FileCopy, resources\apps_previous.png, theme\apps_previous.png
IfNotExist, theme\icon_network_active.png
	FileCopy, resources\icon_network_active.png, theme\icon_network_active.png
IfNotExist, theme\icon_usbgecko_active.png
	FileCopy, resources\icon_usbgecko_active.png, theme\icon_usbgecko_active.png

SetWorkingDir, theme

;setup bitmap
global pBitmap
pBitmap:=Gdip_CreateBitmap(640, 480)
G := Gdip_GraphicsFromImage(pBitmap)

;background.png
pBackground := Gdip_CreateBitmapFromFile("background.png")
Width := Gdip_GetImageWidth(pBackground), Height := Gdip_GetImageHeight(pBackground)
If (Width != 640)
{
	MsgBox,,Error!, Error! background.png is not sized correctly
	return
}	
If (Height != 480)
{
	MsgBox,,Error!, Error! background.png is not sized correctly
	return
}	
Gdip_DrawImage(G, pBackground, 0, 0, Width, Height, 0, 0, Width, Height)
Gdip_DisposeImage(pBackground)

;bubble1 postions
Random, x1, 10, 630
Random, x2, 10, 630
Random, y1, 30, 470
Random, y2, 30, 470

if x1 := x2
	Random, x2, %x1% + 10, 630
if y1 := y2
	Random, y2, %y1% + 10, 470

;bubble1.png
pBubble1 := Gdip_CreateBitmapFromFile("bubble1.png")
Width := Gdip_GetImageWidth(pBubble1), Height := Gdip_GetImageHeight(pBubble1)
If (Width != 64)
{
	MsgBox,,Error!, Error! bubble1.png is not sized correctly
	return
}	
If (Height != 64)
{
	MsgBox,,Error!, Error! bubble1.png is not sized correctly
	return
}	
Gdip_DrawImage(G, pBubble1, x1, y1, Width, Height, 0, 0, Width, Height)
Gdip_DrawImage(G, pBubble1, x2, y2, Width, Height, 0, 0, Width, Height)
Gdip_DisposeImage(pBubble1)

;bubble2 postions
Random, x1, 10, 630
Random, x2, 10, 630
Random, y1, 30, 470
Random, y2, 30, 470

if x1 := x2
	Random, x2, %x1% + 10, 630
if y1 := y2
	Random, y2, %y1% + 10, 470

;bubble2.png
pBubble2 := Gdip_CreateBitmapFromFile("bubble2.png")
Width := Gdip_GetImageWidth(pBubble2), Height := Gdip_GetImageHeight(pBubble2)
If (Width != 64)
{
	MsgBox,,Error!, Error! bubble2.png is not sized correctly
	return
}	
If (Height != 64)
{
	MsgBox,,Error!, Error! bubble2.png is not sized correctly
	return
}	
Gdip_DrawImage(G, pBubble2, x1, y1, Width, Height, 0, 0, Width, Height)
Gdip_DrawImage(G, pBubble2, x2, y2, Width, Height, 0, 0, Width, Height)
Gdip_DisposeImage(pBubble2)

;bubble3 postions
Random, x1, 10, 630
Random, x2, 10, 630
Random, y1, 30, 470
Random, y2, 30, 470

if x1 := x2
	Random, x2, %x1% + 10, 630
if y1 := y2
	Random, y2, %y1% + 10, 470

;bubble3.png
pBubble3 := Gdip_CreateBitmapFromFile("bubble3.png")
Width := Gdip_GetImageWidth(pBubble3), Height := Gdip_GetImageHeight(pBubble3)
If (Width != 64)
{
	MsgBox,,Error!, Error! bubble3.png is not sized correctly
	return
}	
If (Height != 64)
{
	MsgBox,,Error!, Error! bubble3.png is not sized correctly
	return
}	
Gdip_DrawImage(G, pBubble3, x1, y1, Width, Height, 0, 0, Width, Height)
Gdip_DrawImage(G, pBubble3, x2, y2, Width, Height, 0, 0, Width, Height)
Gdip_DisposeImage(pBubble3)

;apps_list.png
pApps_list := Gdip_CreateBitmapFromFile("apps_list.png")
Width := Gdip_GetImageWidth(pApps_list), Height := Gdip_GetImageHeight(pApps_list)
If (Width != 432)
{
	MsgBox,,Error!, Error! apps_list.png is not sized correctly
	return
}	
If (Height != 64)
{
	MsgBox,,Error!, Error! apps_list.png is not sized correctly
	return
}	
Gdip_DrawImage(G, pApps_list, 105, 124, Width, Height, 0, 0, Width, Height)
Gdip_DrawImage(G, pApps_list, 105, 188, Width, Height, 0, 0, Width, Height)
Gdip_DrawImage(G, pApps_list, 105, 252, Width, Height, 0, 0, Width, Height)
Gdip_DrawImage(G, pApps_list, 105, 316, Width, Height, 0, 0, Width, Height)
Gdip_DisposeImage(pApps_list)

;apps_list_hover.png
pApps_list_hover := Gdip_CreateBitmapFromFile("apps_list_hover.png")
Width := Gdip_GetImageWidth(pApps_list_hover), Height := Gdip_GetImageHeight(pApps_list_hover)
If (Width != 432)
{
	MsgBox,,Error!, Error! apps_list_hover.png is not sized correctly
	return
}	
If (Height != 64)
{
	MsgBox,,Error!, Error! apps_list_hover.png is not sized correctly
	return
}	
Gdip_DrawImage(G, pApps_list_hover, 105, 60, Width, Height, 0, 0, Width, Height)
Gdip_DisposeImage(pApps_list_hover)

;icon_network_active.png
pIcon_network_active := Gdip_CreateBitmapFromFile("icon_network_active.png")
Width := Gdip_GetImageWidth(pIcon_network_active), Height := Gdip_GetImageHeight(pIcon_network_active)
If (Width != 32)
{
	MsgBox,,Error!, Error! icon_network_active.png is not sized correctly
	return
}	
If (Height != 32)
{
	MsgBox,,Error!, Error! icon_network_active.png is not sized correctly
	return
}	
Gdip_DrawImage(G, pIcon_network_active, 577, 412, Width, Height, 0, 0, Width, Height)
Gdip_DisposeImage(pIcon_network_active)

;icon_usbgecko_active.png
pIcon_usbgecko_active := Gdip_CreateBitmapFromFile("icon_usbgecko_active.png")
Width := Gdip_GetImageWidth(pIcon_usbgecko_active), Height := Gdip_GetImageHeight(pIcon_usbgecko_active)
If (Width != 32)
{
	MsgBox,,Error!, Error! icon_usbgecko_active.png is not sized correctly
	return
}	
If (Height != 32)
{
	MsgBox,,Error!, Error! icon_gecko_active.png is not sized correctly
	return
}	
Gdip_DrawImage(G, pIcon_usbgecko_active, 545, 412, Width, Height, 0, 0, Width, Height)
Gdip_DisposeImage(pIcon_usbgecko_active)

;apps_previous.png
pApps_previous := Gdip_CreateBitmapFromFile("apps_previous.png")
Width := Gdip_GetImageWidth(pApps_previous), Height := Gdip_GetImageHeight(pApps_previous)
If (Width != 64)
{
	MsgBox,,Error!, Error! apps_previous.png is not sized correctly
	return
}	
If (Height != 64)
{
	MsgBox,,Error!, Error! apps_previous.png is not sized correctly
	return
}	
Gdip_DrawImage(G, pApps_previous, 25, 190, Width, Height, 0, 0, Width, Height)
Gdip_DisposeImage(pApps_previous)

;apps_next.png
pApps_next := Gdip_CreateBitmapFromFile("apps_next.png")
Width := Gdip_GetImageWidth(pApps_next), Height := Gdip_GetImageHeight(pApps_next)
If (Width != 64)
{
	MsgBox,,Error!, Error! apps_next.png is not sized correctly
	return
}	
If (Height != 64)
{
	MsgBox,,Error!, Error! apps_next.png is not sized correctly
	return
}	
Gdip_DrawImage(G, pApps_next, 553, 190, Width, Height, 0, 0, Width, Height)
Gdip_DisposeImage(pApps_next)

;hbc.png
SetWorkingDir, ..
pHbc := Gdip_CreateBitmapFromFile("resources\hbc.png")
Width := Gdip_GetImageWidth(pHbc), Height := Gdip_GetImageHeight(pHbc)
Gdip_DrawImage(G, pHbc, 27, 414, Width, Height, 0, 0, Width, Height)
Gdip_DisposeImage(pHbc)

;Read theme.xml
check := xpath_load(themexml, "theme\theme.xml")
if check != 1
{
	MsgBox Error! No theme.xml found in theme.zip. Not a valid theme.
	return
}
red := xpath(themexml, "/theme/font_color/red/text()")
blue := xpath(themexml, "/theme/font_color/blue/text()")
green := xpath(themexml, "/theme/font_color/green/text()")
alpha := xpath(themexml, "/theme/font_color/alpha/text()")

SetFormat, Integer, hex
alpha += 0x100
red   += 0x100
green += 0x100
blue  += 0x100
argb := "c" SubStr( alpha,-1 ) . SubStr( Red,-1 ) . SubStr( green,-1 ) . SubStr( blue,-1 )

;Write the app text
Font := "Liberation Sans"
options := "x258 y70 s17 " argb " Bold"
Gdip_TextToGraphics(G, "Lorem Ipsum", options, Font)
options := "x258 y95 s17 " argb " Bold"
Gdip_TextToGraphics(G, "Et dolore magna aliqua", options, Font)
options := "x258 y134 s17 " argb " Bold"
Gdip_TextToGraphics(G, "Lorem Ipsum", options, Font)
options := "x258 y157 s17 " argb " Bold"
Gdip_TextToGraphics(G, "Dolor sit amet", options, Font)
options := "x258 y198 s17 " argb " Bold"
Gdip_TextToGraphics(G, "Lorem Ipsum", options, Font)
options := "x258 y223 s17 " argb " Bold"
Gdip_TextToGraphics(G, "Consectetur adipisicing elit", options, Font)
options := "x258 y262 s17 " argb " Bold"
Gdip_TextToGraphics(G, "Lorem Ipsum", options, Font)
options := "x258 y287 s17 " argb " Bold"
Gdip_TextToGraphics(G, "Sed do eiusmod tempor", options, Font)
options := "x258 y326 s17 " argb " Bold"
Gdip_TextToGraphics(G, "Lorem Ipsum", options, Font)
options := "x258 y351 s17 " argb " Bold"
Gdip_TextToGraphics(G, "Incididunt ut labore", options, Font)
Return, 2
}

Browse:
FileSelectFile, PathToTheme,,, Select theme.zip, *.zip
GuiControl,, ThemePath, %PathToTheme%
return

PrevSave:
gui, 2: Destroy
GoSub Save
Return

Save:
;Save
FileSelectFile, SavePath, s,, Select save location:, *.png
If SavePath
{	
	If SubStr(SavePath, -2, 3) != "png"
		SavePath := SavePath ".png"
	Gdip_SaveBitmapToFile(pBitmap, SavePath)
}
Gdip_DisposeImage(pBitmap)
Gdip_DeleteGraphics(G)
Gdip_Shutdown(pToken)
FileRemoveDir, theme, 1
If SavePath
	MsgBox Finished!
Return